diff --git a/test/validation/api/crypto/crypto.h b/test/validation/api/crypto/crypto.h
index 078a1909f..7c248d9eb 100644
--- a/test/validation/api/crypto/crypto.h
+++ b/test/validation/api/crypto/crypto.h
@@ -9,36 +9,6 @@
 
 #include "odp_cunit_common.h"
 
-/* test functions: */
-void crypto_test_enc_alg_null(void);
-void crypto_test_dec_alg_null(void);
-void crypto_test_enc_alg_3des_cbc(void);
-void crypto_test_enc_alg_3des_cbc_ovr_iv(void);
-void crypto_test_dec_alg_3des_cbc(void);
-void crypto_test_dec_alg_3des_cbc_ovr_iv(void);
-void crypto_test_enc_alg_aes_cbc(void);
-void crypto_test_enc_alg_aes_cbc_ovr_iv(void);
-void crypto_test_dec_alg_aes_cbc(void);
-void crypto_test_dec_alg_aes_cbc_ovr_iv(void);
-void crypto_test_enc_alg_aes_ctr(void);
-void crypto_test_enc_alg_aes_ctr_ovr_iv(void);
-void crypto_test_dec_alg_aes_ctr(void);
-void crypto_test_dec_alg_aes_ctr_ovr_iv(void);
-void crypto_test_enc_alg_aes_gcm(void);
-void crypto_test_enc_alg_aes_gcm_ovr_iv(void);
-void crypto_test_dec_alg_aes_gcm(void);
-void crypto_test_dec_alg_aes_gcm_ovr_iv(void);
-void crypto_test_gen_alg_hmac_md5(void);
-void crypto_test_check_alg_hmac_md5(void);
-void crypto_test_gen_alg_hmac_sha1(void);
-void crypto_test_check_alg_hmac_sha1(void);
-void crypto_test_gen_alg_hmac_sha256(void);
-void crypto_test_check_alg_hmac_sha256(void);
-void crypto_test_gen_alg_hmac_sha512(void);
-void crypto_test_check_alg_hmac_sha512(void);
-void crypto_test_gen_alg_aes_gmac(void);
-void crypto_test_check_alg_aes_gmac(void);
-
 /* test arrays: */
 extern odp_testinfo_t crypto_suite[];
 
diff --git a/test/validation/api/crypto/odp_crypto_test_inp.c b/test/validation/api/crypto/odp_crypto_test_inp.c
index 7e7bc5c1c..748a64dcf 100644
--- a/test/validation/api/crypto/odp_crypto_test_inp.c
+++ b/test/validation/api/crypto/odp_crypto_test_inp.c
@@ -635,7 +635,7 @@ static int check_alg_null(void)
 	return check_alg_support(ODP_CIPHER_ALG_NULL, ODP_AUTH_ALG_NULL);
 }
 
-void crypto_test_enc_alg_null(void)
+static void crypto_test_enc_alg_null(void)
 {
 	unsigned int test_vec_num = (sizeof(null_reference) /
 				     sizeof(null_reference[0]));
@@ -649,7 +649,7 @@ void crypto_test_enc_alg_null(void)
 			 false);
 }
 
-void crypto_test_dec_alg_null(void)
+static void crypto_test_dec_alg_null(void)
 {
 	unsigned int test_vec_num = (sizeof(null_reference) /
 				     sizeof(null_reference[0]));
@@ -672,7 +672,7 @@ static int check_alg_3des_cbc(void)
  * operation for 3DES_CBC algorithm. IV for the operation is the session IV.
  * In addition the test verifies if the implementation can use the
  * packet buffer as completion event buffer.*/
-void crypto_test_enc_alg_3des_cbc(void)
+static void crypto_test_enc_alg_3des_cbc(void)
 {
 	unsigned int test_vec_num = (sizeof(tdes_cbc_reference) /
 				     sizeof(tdes_cbc_reference[0]));
@@ -689,7 +689,7 @@ void crypto_test_enc_alg_3des_cbc(void)
 /* This test verifies the correctness of encode (plaintext -> ciphertext)
  * operation for 3DES_CBC algorithm. IV for the operation is the operation IV.
  * */
-void crypto_test_enc_alg_3des_cbc_ovr_iv(void)
+static void crypto_test_enc_alg_3des_cbc_ovr_iv(void)
 {
 	unsigned int test_vec_num = (sizeof(tdes_cbc_reference) /
 				     sizeof(tdes_cbc_reference[0]));
@@ -708,7 +708,7 @@ void crypto_test_enc_alg_3des_cbc_ovr_iv(void)
  * In addition the test verifies if the implementation can use the
  * packet buffer as completion event buffer.
  * */
-void crypto_test_dec_alg_3des_cbc(void)
+static void crypto_test_dec_alg_3des_cbc(void)
 {
 	unsigned int test_vec_num = (sizeof(tdes_cbc_reference) /
 				     sizeof(tdes_cbc_reference[0]));
@@ -727,7 +727,7 @@ void crypto_test_dec_alg_3des_cbc(void)
  * In addition the test verifies if the implementation can use the
  * packet buffer as completion event buffer.
  * */
-void crypto_test_dec_alg_3des_cbc_ovr_iv(void)
+static void crypto_test_dec_alg_3des_cbc_ovr_iv(void)
 {
 	unsigned int test_vec_num = (sizeof(tdes_cbc_reference) /
 				     sizeof(tdes_cbc_reference[0]));
@@ -750,7 +750,7 @@ static int check_alg_aes_gcm(void)
  * operation for AES128_GCM algorithm. IV for the operation is the session IV.
  * In addition the test verifies if the implementation can use the
  * packet buffer as completion event buffer.*/
-void crypto_test_enc_alg_aes_gcm(void)
+static void crypto_test_enc_alg_aes_gcm(void)
 {
 	unsigned int test_vec_num = (sizeof(aes_gcm_reference) /
 				     sizeof(aes_gcm_reference[0]));
@@ -769,7 +769,7 @@ void crypto_test_enc_alg_aes_gcm(void)
  * operation for AES128_GCM algorithm. IV for the operation is the session IV.
  * In addition the test verifies if the implementation can use the
  * packet buffer as completion event buffer.*/
-void crypto_test_enc_alg_aes_gcm_ovr_iv(void)
+static void crypto_test_enc_alg_aes_gcm_ovr_iv(void)
 {
 	unsigned int test_vec_num = (sizeof(aes_gcm_reference) /
 				     sizeof(aes_gcm_reference[0]));
@@ -789,7 +789,7 @@ void crypto_test_enc_alg_aes_gcm_ovr_iv(void)
  * In addition the test verifies if the implementation can use the
  * packet buffer as completion event buffer.
  * */
-void crypto_test_dec_alg_aes_gcm(void)
+static void crypto_test_dec_alg_aes_gcm(void)
 {
 	unsigned int test_vec_num = (sizeof(aes_gcm_reference) /
 				     sizeof(aes_gcm_reference[0]));
@@ -809,7 +809,7 @@ void crypto_test_dec_alg_aes_gcm(void)
  * In addition the test verifies if the implementation can use the
  * packet buffer as completion event buffer.
  * */
-void crypto_test_dec_alg_aes_gcm_ovr_iv(void)
+static void crypto_test_dec_alg_aes_gcm_ovr_iv(void)
 {
 	unsigned int test_vec_num = (sizeof(aes_gcm_reference) /
 				     sizeof(aes_gcm_reference[0]));
@@ -833,7 +833,7 @@ static int check_alg_aes_cbc(void)
  * operation for AES128_CBC algorithm. IV for the operation is the session IV.
  * In addition the test verifies if the implementation can use the
  * packet buffer as completion event buffer.*/
-void crypto_test_enc_alg_aes_cbc(void)
+static void crypto_test_enc_alg_aes_cbc(void)
 {
 	unsigned int test_vec_num = (sizeof(aes_cbc_reference) /
 				     sizeof(aes_cbc_reference[0]));
@@ -851,7 +851,7 @@ void crypto_test_enc_alg_aes_cbc(void)
 /* This test verifies the correctness of encode (plaintext -> ciphertext)
  * operation for AES128_CBC algorithm. IV for the operation is the operation IV.
  * */
-void crypto_test_enc_alg_aes_cbc_ovr_iv(void)
+static void crypto_test_enc_alg_aes_cbc_ovr_iv(void)
 {
 	unsigned int test_vec_num = (sizeof(aes_cbc_reference) /
 				     sizeof(aes_cbc_reference[0]));
@@ -871,7 +871,7 @@ void crypto_test_enc_alg_aes_cbc_ovr_iv(void)
  * In addition the test verifies if the implementation can use the
  * packet buffer as completion event buffer.
  * */
-void crypto_test_dec_alg_aes_cbc(void)
+static void crypto_test_dec_alg_aes_cbc(void)
 {
 	unsigned int test_vec_num = (sizeof(aes_cbc_reference) /
 				     sizeof(aes_cbc_reference[0]));
@@ -891,7 +891,7 @@ void crypto_test_dec_alg_aes_cbc(void)
  * In addition the test verifies if the implementation can use the
  * packet buffer as completion event buffer.
  * */
-void crypto_test_dec_alg_aes_cbc_ovr_iv(void)
+static void crypto_test_dec_alg_aes_cbc_ovr_iv(void)
 {
 	unsigned int test_vec_num = (sizeof(aes_cbc_reference) /
 				     sizeof(aes_cbc_reference[0]));
@@ -915,7 +915,7 @@ static int check_alg_aes_ctr(void)
  * operation for AES128_CTR algorithm. IV for the operation is the session IV.
  * In addition the test verifies if the implementation can use the
  * packet buffer as completion event buffer.*/
-void crypto_test_enc_alg_aes_ctr(void)
+static void crypto_test_enc_alg_aes_ctr(void)
 {
 	unsigned int test_vec_num = (sizeof(aes_ctr_reference) /
 				     sizeof(aes_ctr_reference[0]));
@@ -933,7 +933,7 @@ void crypto_test_enc_alg_aes_ctr(void)
 /* This test verifies the correctness of encode (plaintext -> ciphertext)
  * operation for AES128_CTR algorithm. IV for the operation is the operation IV.
  * */
-void crypto_test_enc_alg_aes_ctr_ovr_iv(void)
+static void crypto_test_enc_alg_aes_ctr_ovr_iv(void)
 {
 	unsigned int test_vec_num = (sizeof(aes_ctr_reference) /
 				     sizeof(aes_ctr_reference[0]));
@@ -953,7 +953,7 @@ void crypto_test_enc_alg_aes_ctr_ovr_iv(void)
  * In addition the test verifies if the implementation can use the
  * packet buffer as completion event buffer.
  * */
-void crypto_test_dec_alg_aes_ctr(void)
+static void crypto_test_dec_alg_aes_ctr(void)
 {
 	unsigned int test_vec_num = (sizeof(aes_ctr_reference) /
 				     sizeof(aes_ctr_reference[0]));
@@ -973,7 +973,7 @@ void crypto_test_dec_alg_aes_ctr(void)
  * In addition the test verifies if the implementation can use the
  * packet buffer as completion event buffer.
  * */
-void crypto_test_dec_alg_aes_ctr_ovr_iv(void)
+static void crypto_test_dec_alg_aes_ctr_ovr_iv(void)
 {
 	unsigned int test_vec_num = (sizeof(aes_ctr_reference) /
 				     sizeof(aes_ctr_reference[0]));
@@ -1000,7 +1000,7 @@ static int check_alg_hmac_md5(void)
  * In addition the test verifies if the implementation can use the
  * packet buffer as completion event buffer.
  * */
-void crypto_test_gen_alg_hmac_md5(void)
+static void crypto_test_gen_alg_hmac_md5(void)
 {
 	unsigned int test_vec_num = (sizeof(hmac_md5_reference) /
 				     sizeof(hmac_md5_reference[0]));
@@ -1014,7 +1014,7 @@ void crypto_test_gen_alg_hmac_md5(void)
 			 false);
 }
 
-void crypto_test_check_alg_hmac_md5(void)
+static void crypto_test_check_alg_hmac_md5(void)
 {
 	unsigned int test_vec_num = (sizeof(hmac_md5_reference) /
 				     sizeof(hmac_md5_reference[0]));
@@ -1040,7 +1040,7 @@ static int check_alg_hmac_sha1(void)
  * In addition the test verifies if the implementation can use the
  * packet buffer as completion event buffer.
  * */
-void crypto_test_gen_alg_hmac_sha1(void)
+static void crypto_test_gen_alg_hmac_sha1(void)
 {
 	unsigned int test_vec_num = (sizeof(hmac_sha1_reference) /
 				     sizeof(hmac_sha1_reference[0]));
@@ -1054,7 +1054,7 @@ void crypto_test_gen_alg_hmac_sha1(void)
 			 false);
 }
 
-void crypto_test_check_alg_hmac_sha1(void)
+static void crypto_test_check_alg_hmac_sha1(void)
 {
 	unsigned int test_vec_num = (sizeof(hmac_sha1_reference) /
 				     sizeof(hmac_sha1_reference[0]));
@@ -1080,7 +1080,7 @@ static int check_alg_hmac_sha256(void)
  * In addition the test verifies if the implementation can use the
  * packet buffer as completion event buffer.
  * */
-void crypto_test_gen_alg_hmac_sha256(void)
+static void crypto_test_gen_alg_hmac_sha256(void)
 {
 	unsigned int test_vec_num = (sizeof(hmac_sha256_reference) /
 				     sizeof(hmac_sha256_reference[0]));
@@ -1094,7 +1094,7 @@ void crypto_test_gen_alg_hmac_sha256(void)
 			 false);
 }
 
-void crypto_test_check_alg_hmac_sha256(void)
+static void crypto_test_check_alg_hmac_sha256(void)
 {
 	unsigned int test_vec_num = (sizeof(hmac_sha256_reference) /
 				     sizeof(hmac_sha256_reference[0]));
@@ -1120,7 +1120,7 @@ static int check_alg_hmac_sha512(void)
  * In addition the test verifies if the implementation can use the
  * packet buffer as completion event buffer.
  * */
-void crypto_test_gen_alg_hmac_sha512(void)
+static void crypto_test_gen_alg_hmac_sha512(void)
 {
 	unsigned int test_vec_num = (sizeof(hmac_sha512_reference) /
 				     sizeof(hmac_sha512_reference[0]));
@@ -1134,7 +1134,7 @@ void crypto_test_gen_alg_hmac_sha512(void)
 			 false);
 }
 
-void crypto_test_check_alg_hmac_sha512(void)
+static void crypto_test_check_alg_hmac_sha512(void)
 {
 	unsigned int test_vec_num = (sizeof(hmac_sha512_reference) /
 				     sizeof(hmac_sha512_reference[0]));
@@ -1153,7 +1153,7 @@ static int check_alg_aes_gmac(void)
 	return check_alg_support(ODP_CIPHER_ALG_NULL, ODP_AUTH_ALG_AES_GMAC);
 }
 
-void crypto_test_gen_alg_aes_gmac(void)
+static void crypto_test_gen_alg_aes_gmac(void)
 {
 	unsigned int test_vec_num = (sizeof(aes_gmac_reference) /
 				     sizeof(aes_gmac_reference[0]));
@@ -1167,7 +1167,7 @@ void crypto_test_gen_alg_aes_gmac(void)
 			 false);
 }
 
-void crypto_test_check_alg_aes_gmac(void)
+static void crypto_test_check_alg_aes_gmac(void)
 {
 	unsigned int test_vec_num = (sizeof(aes_gmac_reference) /
 				     sizeof(aes_gmac_reference[0]));